#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define START       1
#define END         2
#define PLUSPLUS    3
#define MINUSMINUS  4
#define PUSH        5
#define POP         6
#define IN          7
#define OUT         8
#define TURN        9
#define ZERO        10
#define CALL        11
#define ADD         12
#define SUB         13
#define MUL         14
#define DIV         15

struct IMG
{
    int channel;
    int sx,sy;
    int maxv;
    unsigned char * img;
};

int ReadPPM(char * fname,struct IMG * img)
{
    FILE * fp=NULL;
    char ch;
    fp=fopen(fname,"rb");
    if(fp==NULL)
    {
        perror("Can't open the file");
        exit(-1);
    }
    fscanf(fp,"%c%d%d%d%d%*c",&ch,&img->channel,&img->sx,&img->sy,&img->maxv);
    if(img->channel==6)
    {
        img->img=(unsigned char *)malloc(img->sx*img->sy*3);
        if(img->img==NULL)
        {
            perror("Can't malloc memory");
            exit(-1);
        }
        fread(img->img,img->sx*img->sy*3,1,fp);
    }
    fclose(fp);
    return 0;
}

struct Dir
{
    int x;
    int y;
};

int to3(int a)
{
    if(a<=50)
        return 0;
    if(a>50&&a<150)
        return 1;
    if(a>=200)
        return 2;
    perror("图片格式模糊不便执行");
}

int toinc(int r,int g,int b)
{
    int i;
    if(to3(r)==0 && to3(g)==0 &&to3(b)==0)
        return START;
    if(to3(r)==2 && to3(g)==2 &&to3(b)==2)
        return END;

    if(to3(r)==0 && to3(g)==0 &&to3(b)==1)
        return PLUSPLUS;
    if(to3(r)==0 && to3(g)==0 &&to3(b)==2)
        return MINUSMINUS;

    if(to3(r)==0 && to3(g)==1 &&to3(b)==1)
        return PUSH;
    if(to3(r)==0 && to3(g)==1 &&to3(b)==2)
        return POP;

    if(to3(r)==0 && to3(g)==2 &&to3(b)==1)
        return IN;
    if(to3(r)==0 && to3(g)==2 &&to3(b)==2)
        return OUT;

    if(to3(r)==1 && to3(g)==0 &&to3(b)==1)
        return TURN;
    if(to3(r)==1 && to3(g)==0 &&to3(b)==0)
        return ZERO;
    if(to3(r)==1 && to3(g)==1 &&to3(b)==1)
        return CALL;

    if(to3(r)==2 && to3(g)==0 &&to3(b)==0)
        return ADD;
    if(to3(r)==2 && to3(g)==0 &&to3(b)==1)
        return SUB;
    if(to3(r)==2 && to3(g)==1 &&to3(b)==0)
        return MUL;
    if(to3(r)==2 && to3(g)==1 &&to3(b)==1)
        return DIV;
}

int decode(struct IMG * img)
{
    struct Dir dir;//代码方向向量
    struct Dir now;//表示当前代码指针
    int stack[1024];
    char ch;
    int inc;//保存指令
    int ptr;//栈指针
    int reg;//这个是寄存器
    int tmp;
    memset(stack,0,sizeof(stack));
    ptr=0;reg=0;
    dir.x=1;
    dir.y=0;//表示向前
    now.x=0;
    now.y=0;
    inc=toinc(img->img[0],img->img[1],img->img[2]);
    while(1)
    {
        tmp=now.y*img->sx*3+now.x*3;
        inc=toinc(img->img[tmp],img->img[tmp+1],img->img[tmp+2]);
        //printf("%d x=%d y=%d\n",inc,now.x,now.y);
        //printf("此时reg=%d stack=%d\n",reg,stack[ptr-1]);
        //getchar();
        switch(inc)
        {
            case START:
                {
                    break;
                }
            case END:
                {
                    return 0;
                }
            case PLUSPLUS:
                {
                    reg++;
                    break;
                }
            case MINUSMINUS:
                {
                    reg--;
                    break;
                }
            case PUSH:
                {
                    stack[ptr]=reg;
                    ptr++;
                    break;
                }
            case POP:
                {
                    ptr--;
                    break;
                }
            case IN:
                {
                    fflush(stdin);
                    ch=getchar();
                    reg=ch;
                    break;
                }
            case OUT:
                {
                    printf("%c",reg);
                    break;
                }
            case TURN:
                {
                    if(stack[ptr-1]>reg)//左转
                    {
                        //printf("左转\n");
                        if(dir.x==1&&dir.y==0)//东
                        {
                            dir.x=0;dir.y=-1;
                        }
                        else if(dir.x==-1&&dir.y==0)//西
                        {
                            dir.x=0;dir.y=1;
                        }
                        else if(dir.x==0&&dir.y==1)//南
                        {
                            dir.x=1;dir.y=0;
                        }
                        else if(dir.x==0&&dir.y==-1)//北
                        {
                            dir.x=-1;dir.y=0;
                        }
                    }
                    else if(stack[ptr-1]<reg)//右转
                    {
                        //printf("右转\n");
                        if(dir.x==1&&dir.y==0)//东
                        {
                            dir.x=0;dir.y=1;
                        }
                        else if(dir.x==-1&&dir.y==0)//西
                        {
                            dir.x=0;dir.y=-1;
                        }
                        else if(dir.x==0&&dir.y==1)//南
                        {
                            dir.x=-1;dir.y=0;
                        }
                        else if(dir.x==0&&dir.y==-1)//北
                        {
                            dir.x=1;dir.y=0;
                        }
                    }
                    else
                    {
                        ;//不变
                    }
                    break;
                }
            case ZERO:
                {
                    reg=0;
                    break;
                }
            case CALL:
                {
                    now.x=reg;
                    now.y=stack[ptr-1];
                    continue;
                    break;
                }
            case ADD:
                {
                    reg=reg+stack[ptr-1];
                    break;
                }
            case SUB:
                {
                    reg=stack[ptr-1]-reg;
                    break;
                }
            case MUL:
                {
                    reg=reg*stack[ptr-1];
                    break;
                }
            case DIV:
                {
                    reg=stack[ptr-1]/reg;
                    break;
                }
        }
        now.x=now.x+dir.x;
        now.y=now.y+dir.y;
    }

    return 0;
}

int main(int argc,char *argv[])
{
    int i,j;
    struct IMG image;
    struct IMG *pimg=&image;
    char filename[64];
    if(argc!=2)
    {
        printf("请输入要编译的文件:");
        scanf("%s",filename);
    }
    else
    {
        strcpy(filename,argv[1]);
    }
    ReadPPM(filename,pimg);
    decode(pimg);
    return 0;
}
